package function.builtin;

import function.*;
import sexpression.*;

public class CONS extends LispFunction {

    private ArgumentValidator argumentValidator;

    public CONS() {
        this.argumentValidator = new ArgumentValidator("CONS");
        this.argumentValidator.setExactNumberOfArguments(2);
    }

    public Cons call(Cons argumentList) {
        argumentValidator.validate(argumentList);

        Cons cdr = (Cons) argumentList.getCdr();
        SExpression firstArgument = argumentList.getCar();
        SExpression secondArgument = cdr.getCar();

        return new Cons(firstArgument, secondArgument);
    }

}
