package function.builtin;

import function.*;
import sexpression.*;

public class LIST extends LispFunction {

    private ArgumentValidator argumentValidator;

    public LIST() {
        this.argumentValidator = new ArgumentValidator("LIST");
    }

    public static Cons makeList(SExpression sexpr) {
        return new Cons(sexpr, Nil.getInstance());
    }

    public Cons call(Cons argumentList) {
        argumentValidator.validate(argumentList);

        return callRecursive(argumentList);
    }

    private Cons callRecursive(Cons argumentList) {
        if (argumentList.nullp())
            return Nil.getInstance();

        SExpression firstArgument = argumentList.getCar();
        Cons remainingArguments = (Cons) argumentList.getCdr();

        return new Cons(firstArgument, callRecursive(remainingArguments));
    }

}
