package function.builtin;

import function.*;
import sexpression.*;

public class PLUS extends LispFunction {

    private ArgumentValidator argumentValidator;

    public PLUS() {
        this.argumentValidator = new ArgumentValidator("+");
        this.argumentValidator.setEveryArgumentExpectedType(LispNumber.class);
    }

    public LispNumber call(Cons argumentList) {
        argumentValidator.validate(argumentList);

        return callTailRecursive(new Cons(LispNumber.ZERO, argumentList));
    }

    private LispNumber callTailRecursive(Cons argumentList) {
        Cons remainingArguments = (Cons) argumentList.getCdr();
        SExpression firstArgument = argumentList.getCar();
        LispNumber number1 = (LispNumber) firstArgument;

        if (remainingArguments.nullp())
            return number1;

        SExpression secondArgument = remainingArguments.getCar();
        LispNumber number2 = (LispNumber) secondArgument;
        LispNumber sum = new LispNumber(number1.getValue().add(number2.getValue()));
        SExpression remainingNumbers = remainingArguments.getCdr();

        if (!remainingNumbers.consp())
            return sum;

        return callTailRecursive(new Cons(sum, remainingNumbers));
    }

}
